// for Arduino0022  24.12.2011
#include "WProgram.h"
  
#include <..\Wire\Wire.h>
#include "I2C_LM75.h"


#define Chip_LM75    0x48

float I2C_LM75Class::getTemp(uint8_t adr) {
  uint8_t chip=Chip_LM75+adr; //0100 1aaa
  float re=0.0;
  uint8_t tempVal=0;
  uint8_t wA=0;
  uint8_t wB=0;
  
  Wire.beginTransmission(chip); // transmit to device typ 0x40 Adresse 4
  Wire.send((uint8_t)0x00);//Pointer 00=Temperatur read only
  Wire.endTransmission();
  
  Wire.requestFrom((uint8_t)chip, (uint8_t)2);
  wA=Wire.receive();//nttttttt  n=1->negative Temperatur n=0->positive Temperatur   ttttttt=Temperatur 0...127C
  wB=Wire.receive();//1xxxxxxx  Bit8 Nachkommastelle: 0.0 oder 0.5 
  Wire.endTransmission();
  
  wB=wB>>7;//0.0 oder 0.5
 
  tempVal=wA>>7;//positiv oder negativ
  wA=wA<<1;  //oberstes Bit wegshiften
  wA=wA>>1;  //Temperatur
  
  re=wA;
  if(wB==1)re=re+0.5;//Nachkommastelle
 
  if(tempVal==1){//negativer Bereich
    re=128-wA;   //128-Temperaturwert
    if(wB==1)re=re+0.5;//Nachkommastelle
    re=re*-1;//Negieren
  } 
  return re;
}

void I2C_LM75Class::setOutPin(uint8_t adr,uint8_t an) {
  uint8_t chip=Chip_LM75+adr; //0100 1aaa
  Wire.beginTransmission(chip); // transmit to device typ 0x40 Adresse 4
  Wire.send((uint8_t)0x01);//Pointer 01=config read/write
  if(an)
    Wire.send((uint8_t)0x04);//set Pin 3 
    else
    Wire.send((uint8_t)0x00);
  Wire.endTransmission();
}

String I2C_LM75Class::getStringTemperatur(uint8_t adr) {
  String s;
 
  uint8_t chip=Chip_LM75+adr; //0100 1aaa
  uint8_t isnegativ=0;
  uint8_t wA=0;
  uint8_t wB=0;
  
  Wire.beginTransmission(chip); // transmit to device typ 0x40 Adresse 4
  Wire.send((uint8_t)0x00);//Pointer 00=Temperatur read only
  Wire.endTransmission();
  
  Wire.requestFrom((uint8_t)chip, (uint8_t)2);
  wA=Wire.receive();//nttttttt  n=1->negative Temperatur n=0->positive Temperatur   ttttttt=Temperatur 0...127C
  wB=Wire.receive();//1xxxxxxx  Bit8 Nachkommastelle: 0.0 oder 0.5 
  Wire.endTransmission();
  
  wB=wB>>7;//0.0 oder 0.5
 
  isnegativ=wA>>7;//positiv oder negativ
  wA=wA<<1;  //oberstes Bit wegshiften
  wA=wA>>1;  //Temperatur
  
  if(isnegativ==1){//negativer Bereich
    s="-"+String(128-wA,DEC);
  } 
  else{
    s=String(wA,DEC);
  }
 
  if(wB==1)//Nachkommastelle
    s=s+".5";
    else
	s=s+".0";
 return s;
}



I2C_LM75Class I2C_LM75;